#ifndef _MBV2LIB_H_
#define _MBV2LIB_H_

#define FILE int

#include "gba.h"

extern int dputchar (int c);
extern void __PrintStr (char *str);
extern int dgetch (void);
extern int dfgetch (void);
extern int dkbhit (void);
extern FILE dfopen (const char *file, const char *type);
extern int dfclose (FILE fp);
extern int dfgetc (FILE fp);
extern int dfputc (int ch, FILE fp);
extern void drewind (FILE fp);
extern void __PrintStrToFile (FILE fp, char *str);

extern int dsprintf(char *buf, const char *fmt, ...);

extern unsigned char __outstr[];

#define dprintf(x...) ({ dsprintf(__outstr, x); __PrintStr(__outstr); })
#define dfprintf(y,x...) ({ dsprintf(__outstr, x); __PrintStrToFile(y,__outstr); })

#ifdef __ANSI_NAMES
  #define printf  dprintf
  #define fprintf dfprintf
  #define putchar dputchar
  #define getch   dgetch
  #define kbhit   dkbhit

  #define fopen   dfopen
  #define fclose  dfclose
  #define fgetc   dfgetc
  #define fputc   dfputc
  #define rewind  drewind
#endif
#endif
